// Controlling a servo position using a potentiometer (variable resistor) 
// by Michal Rinott <http://people.interaction-ivrea.it/m.rinott> 

#include <Servo.h> 

Servo servo;  // create servo object to control a servo 

int potpin = 0;  // analog pin used to connect the potentiometer
int val;    // variable to read the value from the analog pin 



 
void setup() 
{ 
  servo.attach(3);  // 3ピンにサーボ信号線を接続
  } 
 
 
 //サーボによって最大、最小パルスが異なるので
 //FS90用にパルス時間900ms-2100msに合わせ、
 //writeMicroseconds()関数でパルス時間を指定する
void loop() 
{ 
  val = analogRead(potpin);            // reads the value of the potentiometer (value between 0 and 1023) 
  val = map(val, 0, 1023, 900,2100);     // scale it to use it with the servo (value between 0 and 180) 
  servo.writeMicroseconds(val);                  // sets the servo position according to the scaled value 
  delay(15);    
} 


