/*  
  CountUP 明るさセンサーを遮ると
  表示がひとつ増える
 */
 //音階の情報を加える
 #include "pitches.h"
 /* 音階の指定方法
NOTE_C3		:ド
NOTE_CS3	:#ド
NOTE_D3		:レ
NOTE_DS3	:#レ
NOTE_E3		:ミ
NOTE_F3		:ファ
NOTE_FS3	:#ファ
NOTE_G3		:ソ
NOTE_GS3	:#ソ
NOTE_A3		:ラ
NOTE_AS3	:#ラ
NOTE_B3		:シ
NOTE_C4		:ド

音を出すときの命令は
tone(スピーカーのピン:2,音の高さ,長さ);
*/
 
 
 
 //関数の宣言
void display0(); 
void display1();
void display2();
void display3();
void display4();
void display5();
void display6();
void display7();
void display8();
void display9();

 
/*連続してカウントアップしないよう
　入光の状態を記録して、入光から遮光に変化したときだけ
　カウントアップするようにする。
*/

int lastData;  //直前の状態　 
int getData;  //測定した明るさ
int num; //現在の値
int Level = 10; //光を遮られたと判定する値。しきい値

 
// setupのあと{}で囲まれた部分は最初に1回だけ実行される
void setup() {
  //シリアル通信を始める 
  Serial.begin(9600);
  
  //ピンの設定  
  pinMode(A1,INPUT);  //光センサーを入力に設定
  
  pinMode(4, OUTPUT);  //LEDの接続されたピンを出力に設定
  pinMode(6, OUTPUT); 
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);  
  pinMode(11, OUTPUT); 
  pinMode(12, OUTPUT); 
  pinMode(13, OUTPUT);  
  
  getData = analogRead(A1);
  //Serial.println(getData);  //値送信
  //Serial.println(Level);
  if(getData > Level){
   lastData = 1;
}else{lastData = 0;}     //最初の状態を得る入光で1、遮光で0

   //Serial.println(lastData);
 
  num = 0;//カウント初期化
  display0();
  delay(20);  //安定時間
}


// loopのあと{}で囲まれた部分は繰り返される。
void loop() 
{    

  //入光→遮光の変化で加算
     getData = analogRead(A1);
     //Serial.println(getData);  //値送信
    if(getData < Level && lastData ==1)
    {
      lastData = 0; //入光の状態をlastDataに記録
      //Serial.println("+");
      num=num+1;//カウント数を加算   
     //音を出す・・
     tone(2, NOTE_C4,150); //
    //numの値に合わせてどの数字を表示させるかの分岐処理
        switch(num)
        {
          case 0 : display0();break;
          case 1 : display1();break;
          case 2 : display2();break;
          case 3 : display3();break;
          case 4 : display4();break;
          case 5 : display5();break;
          case 6 : display6();break;
          case 7 : display7();break;
          case 8 : display8();break;
          case 9 : display9();break;
          case 10 : num= 0;display0();break;
        }
     
        
      } else if(getData >= Level){
	lastData = 1;
       //Serial.println(lastData);
      } else if(getData < Level){
    lastData = 0;
  //Serial.println(lastData);   
  } 
    delay(20); 		
}

//ＬＥＤ表示関数
void display0() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, HIGH);
 digitalWrite(11, HIGH);
 digitalWrite(12, HIGH);
 digitalWrite(13, LOW);
}

void display1() {
 digitalWrite(4, LOW);
 digitalWrite(6, HIGH);
 digitalWrite(7, LOW);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, LOW);
}

void display2() {
 digitalWrite(4, HIGH);
 digitalWrite(6, LOW);
 digitalWrite(7, HIGH);
 digitalWrite(8, HIGH);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, HIGH);
}

void display3() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, HIGH);
}

void display4() {
 digitalWrite(4, LOW);
 digitalWrite(6, HIGH);
 digitalWrite(7, LOW);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}

void display5() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, LOW);
 digitalWrite(11, LOW);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}

void display6() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, HIGH);
 digitalWrite(11, LOW);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}

void display7() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, LOW);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, LOW);
}

void display8() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, HIGH);
 digitalWrite(11, HIGH);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}
void display9() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}
