/*
  AnalogRead_LED_Brightness:  ボリュームの値を読み込みLEDの明るさに反映する。
  アナログの入力はボリュームA0または明るさセンサーA1を使用
 */
 
 //アナログ入力の種類を指定する
 #define input A0
 
// LED接続ピンを指定する 5,6,9,10,11のみ
int led = 10;
//ボリュームから読み取った値
int val;

// setupのあと{}で囲まれた部分は最初に1回だけ実行される
void setup() {                
  // LED点灯させるピンを出力ピンに指定する
  pinMode(led, OUTPUT);     
}

// loopのあと{}で囲まれた部分は繰り返される。
//明るさは0-255の範囲
void loop() {
  val = analogRead(input);  //入力されたアナログ値を読む0-1024
  val = val/4;            //LEDの明るさは0-255の範囲なので4で割る。
  analogWrite(led, val);   // LEDの明るさをvalの値にする。
  delay(50);               // 繰り返しまでの待ち時間
}
