/*
  AnalogRead_LED_Color:  ボリュームの値を読み込み赤と青のLEDの比率を変える。
  Analogは　ボリュームA0 を使用
 */

//アナログ入力の指定する
 #define input A0
 
// カラーLED接続ピンを指定する 9:赤,5:青,10:緑
int A_led = 5;
int B_led = 10;
//ボリュームから読み取った値
int val;

// setupのあと{}で囲まれた部分は最初に1回だけ実行される
void setup() {                
  // LED点灯させるピンを出力ピンに指定する
  pinMode(A_led, OUTPUT);
  pinMode(B_led, OUTPUT);  
}

// loopのあと{}で囲まれた部分は繰り返される。
//明るさは0-255の範囲
void loop() {
  val = analogRead(input);  //入力されたアナログ値を読む0-1024
  val = val/4;            //LEDの明るさは0-255の範囲なので4で割る。
  analogWrite(A_led, val);   // 青LEDの明るさをvalの値にする。
  analogWrite(B_led,255-val);//赤LEDは青と反比例
  delay(50);               // 繰り返しまでの待ち時間
}
