/* 3 minutes timer
  ボタンでスタート
   1秒ごとに緑LEDを点滅
  ７セグを時計に見立てて、30秒ごとに進める
  3分経ったら赤LED点滅とブザーでピピピ音を鳴らす。
  ボタンを押したら終了
*/

#define  Button 16
#define  Buzzer 2
#define  Red 9
#define  Green 10

//<変数一覧>

//状態を表わす
int jyoutai = 0; 
/*
0:タイマー停止中
1:計測中
2:タイムアップ


*/
unsigned long nowTime;  //現在の時間（ミリ秒）
unsigned long countStart; //カウント開始時の時間（ミリ秒）

long counter;          //カウンタ（ミリ秒）
int second;            //経過秒数

int nowButton;  
int lastButton;     


//関数の宣言
void allClear();

//関数名を数字ではじめることはできないので_をつけています
void _30sec();
void _60sec();
void _90sec();
void _120sec();
void _150sec();
void _180sec();
void syuryo();


void setup() {
  // セットアップ
  
  //Serial.begin(9600);  //デバッグ用　シリアル通信

  //ピンの入出力設定

  //入力
  pinMode (16,INPUT);
  
  //出力
  pinMode (9,OUTPUT);  //赤LED
  pinMode (10,OUTPUT);  //緑LED  
  
  pinMode (4,OUTPUT);  //7セグメントLED
  pinMode (5,OUTPUT);  //7セグメントLED  
  pinMode (6,OUTPUT);  //7セグメントLED 
  pinMode (7,OUTPUT);  //7セグメントLED
  pinMode (8,OUTPUT);  //7セグメントLED  
  pinMode (12,OUTPUT);  //7セグメントLED    
  
  pinMode(2,OUTPUT);  //ブザー
  
  //最初に起動状態にする 
  allClear();
}

  // メインループ
void loop() {

if(jyoutai == 1)
{
    nowTime = millis();
    
    //経過時間を計算する
    counter = nowTime-countStart;
    if(counter > 1000)
    {
      countStart = nowTime;  //今の時間をカウンタ開始時間にする   
      second = second + 1;   //秒数を追加
      //Serial.println(second);  //デバッグ用　秒数送信

    }
}
  
  
  //状態0のときの処理。スタートボタンが押されるのを待つ
  if(jyoutai == 0)
  {
  nowButton = digitalRead(Button);
  if(nowButton ==1 && lastButton == 0)
    {
      jyoutai = 1;
      second = 0;              //時間カウンタのリセット
      counter= 0;
      countStart = millis();   //今の時間をカウンタスタート時間とする     
    }else
    {
    lastButton = nowButton;
    }
  }
  

  //計測中の処理１　＜毎秒ごとにＬＥＤ点滅＞
  if(jyoutai == 1)
 { 
  if(second >= 1 && ( 500 > counter && counter >=0))
  {
    digitalWrite(Green,HIGH);
  }else 
  {
    digitalWrite(Green,LOW);
  }
 }
 
 //計測中の処理２ ＜３０秒ごとの処理＞
 if(jyoutai == 1)
 {
  if(second == 30){_30sec();}    //30秒目
  if(second == 60){_60sec();}    //60秒目
  if(second == 90){_90sec();}    //90秒目
  if(second == 120){_120sec();}  //120秒目
  if(second == 150){_150sec();}  //150秒目
  if(second == 180)              //180秒目
  {
    _180sec();  //180秒目のLED処理
   jyoutai = 2;  //状態をタイムアップにする
  }  
 }
 
 if(jyoutai == 2)
 {
   digitalWrite(Green,LOW);
   lastButton = digitalRead(Button); //ボタンが押されたままタイムアップして即終了しないように
   
   //以下の処理をボタンが押されて状態0になるまで繰り返す。
   while(jyoutai == 2)
   {
     //停止ボタンのチェック
     nowButton = digitalRead(Button);
  if(nowButton ==1 && lastButton == 0)
    {
      syuryo();    //終了処理
    }else
    {
    lastButton = nowButton;
    }
    //音と光の表示    
    digitalWrite(Red,HIGH);  //赤LED点灯
    tone(Buzzer,1047,100);    //ブザーを0.2秒間ならす
    delay(200);              //0.5秒経ったら
    digitalWrite(Red,LOW);    //赤LEDを消す
    delay(200);                //0.2秒間消灯
   } 
 }
 
}//loopの終わり

//関数本体

//初期状態
void allClear()
{
  //LEDを全部消す
  digitalWrite(4,LOW);
  digitalWrite(5,LOW);
  digitalWrite(6,LOW);
  digitalWrite(7,LOW);
  digitalWrite(8,LOW);
  digitalWrite(12,LOW);
  digitalWrite(Red,LOW);
  digitalWrite(Green,LOW);
   
  
  //状態を起動前に戻す
  jyoutai = 0;
  countStart = 0;
  counter = 0;
  second = 0;
  lastButton = 1;  //ボタンを押したまま電源投入して即スタートしないように
 
}


//30秒経過
void _30sec()
{
  //時間経過のLEDをつける
  digitalWrite(4,HIGH);
}

//60秒経過
void _60sec()
{
  digitalWrite(5,HIGH);
}

//90秒経過
void _90sec()
{
  digitalWrite(6,HIGH);
}

//120秒経過
void _120sec()
{
  digitalWrite(7,HIGH);
}

//150秒経過
void _150sec()
{
  digitalWrite(8,HIGH);
}

//180秒経過
void _180sec()
{
 digitalWrite(12,HIGH);
}

//終了処理
void syuryo()
{
  jyoutai = 0;
  allClear();
}


