/*  
  dice 電子サイコロ
  プッシュボタンを押すとシャッフル開始
  もう一度押すとストップ
 */
 
 #define  btn 16
 
 //関数の宣言
void display1();
void display2();
void display3();
void display4();
void display5();
void display6();
 
/*状態遷移 s
  s=0:シャッフル開始前、開始ボタンを待つ状態
  s=1:シャッフル開始、開始ボタンが押されたままの状態
  s=2:シャッフル中、開始ボタンが一度離され、停止ボタンとして待つ間
  s=3:シャッフル停止、停止ボタンが押されたままの状態
*/
int s; 
int v=50;  //シャッフルのスピード(画面切替の待ち時間)
 
// the setup routine runs once when you press reset:
void setup() {
   // デバッグ用にパソコンとの通信速度の設定
  //Serial.begin(9600);  
  
  //ピンの設定  
  pinMode(16,INPUT);  //スタートストップボタン
  
  pinMode(4, OUTPUT);  //LED表示
  pinMode(6, OUTPUT); 
  pinMode(7, OUTPUT);
  pinMode(8, OUTPUT);  
  pinMode(11, OUTPUT); 
  pinMode(12, OUTPUT); 
  pinMode(13, OUTPUT);  
  
  //状態は0から始める
  s = 0; 
}

// the loop routine runs over and over again forever:
void loop() 
{
  //状態1に移行：ボタンが押されたのでシャッフル開始
    if(s==0 && digitalRead(btn)==1)
    {
      s=1;      
     
       //シャッフル開始。whileを使って表示を高速で繰り返す
       while(1)
          {
            //シャッフル開始後、ボタンが離されたら状態２に移行
            //停止のためボタンが押されるのを待つ
            if(s==1 && digitalRead(btn)==0)
            {
              s=2;      
            }  
            
            display1(); //サイコロ1表示
            //シャッフル中に停止ボタンが押されたら状態３に移行して繰り返しを抜ける
            if(s==2 && digitalRead(btn) == HIGH){s=3;break;}
              delay(v); 
            display2(); //サイコロ2表示
            if(s==2 && digitalRead(btn) == HIGH){s=3;break;}
              delay(v);
            display3(); //サイコロ3表示
            if(s==2 && digitalRead(btn) == HIGH){s=3;break;}
              delay(v);
            display4(); //サイコロ4表示
            if(s==2 && digitalRead(btn) == HIGH){s=3;break;}
              delay(v);
            display5(); //サイコロ5表示
            if(s==2 && digitalRead(btn) == HIGH){s=3;break;}
              delay(v);
            display6(); //サイコロ6表示
            if(s==2 && digitalRead(btn) == HIGH){s=3;break;}
              delay(v); 
          }
      }
      
      
      //シャッフルを終えた後の処理
      //最初の状態s=0に戻す 
      if(s==3 && digitalRead(btn)==0)
      {
        s=0;      
      }
}
   
        

void display1() {
 digitalWrite(4, LOW);
 digitalWrite(6, HIGH);
 digitalWrite(7, LOW);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, LOW);
}

void display2() {
 digitalWrite(4, HIGH);
 digitalWrite(6, LOW);
 digitalWrite(7, HIGH);
 digitalWrite(8, HIGH);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, HIGH);
}

void display3() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, LOW);
 digitalWrite(13, HIGH);
}

void display4() {
 digitalWrite(4, LOW);
 digitalWrite(6, HIGH);
 digitalWrite(7, LOW);
 digitalWrite(8, LOW);
 digitalWrite(11, HIGH);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}

void display5() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, LOW);
 digitalWrite(11, LOW);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}

void display6() {
 digitalWrite(4, HIGH);
 digitalWrite(6, HIGH);
 digitalWrite(7, HIGH);
 digitalWrite(8, HIGH);
 digitalWrite(11, LOW);
 digitalWrite(12, HIGH);
 digitalWrite(13, HIGH);
}

